{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_List
  ( d_C_elemIndex
  , nd_C_elemIndex
  , d_C_elemIndices
  , nd_C_elemIndices
  , d_C_find
  , nd_C_find
  , d_C_findIndex
  , nd_C_findIndex
  , d_C_findIndices
  , nd_C_findIndices
  , d_C_nub
  , nd_C_nub
  , d_C_nubBy
  , nd_C_nubBy
  , d_C_delete
  , nd_C_delete
  , d_C_deleteBy
  , nd_C_deleteBy
  , d_OP_backslash_backslash
  , nd_OP_backslash_backslash
  , d_C_union
  , nd_C_union
  , d_C_unionBy
  , nd_C_unionBy
  , d_C_intersect
  , nd_C_intersect
  , d_C_intersectBy
  , nd_C_intersectBy
  , d_C_intersperse
  , d_C_intercalate
  , d_C_transpose
  , d_C_diagonal
  , d_C_permutations
  , d_C_partition
  , nd_C_partition
  , d_C_group
  , nd_C_group
  , d_C_groupBy
  , nd_C_groupBy
  , d_C_splitOn
  , nd_C_splitOn
  , d_C_split
  , nd_C_split
  , d_C_inits
  , d_C_tails
  , d_C_replace
  , d_C_isPrefixOf
  , nd_C_isPrefixOf
  , d_C_isSuffixOf
  , nd_C_isSuffixOf
  , d_C_isInfixOf
  , nd_C_isInfixOf
  , d_C_sortBy
  , nd_C_sortBy
  , d_C_insertBy
  , nd_C_insertBy
  , d_C_last
  , d_C_init
  , d_C_sum
  , nd_C_sum
  , d_C_product
  , nd_C_product
  , d_C_maximum
  , nd_C_maximum
  , d_C_maximumBy
  , nd_C_maximumBy
  , d_C_minimum
  , nd_C_minimum
  , d_C_minimumBy
  , nd_C_minimumBy
  , d_C_scanl
  , nd_C_scanl
  , d_C_scanl1
  , nd_C_scanl1
  , d_C_scanr
  , nd_C_scanr
  , d_C_scanr1
  , nd_C_scanr1
  , d_C_mapAccumL
  , nd_C_mapAccumL
  , d_C_mapAccumR
  , nd_C_mapAccumR
  , d_C_cycle
  , d_C_unfoldr
  , nd_C_unfoldr )
  where

import Basics
import qualified Curry_Maybe
import qualified Curry_Prelude


d_C_elemIndex :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int
d_C_elemIndex x1 x2 cd cs = d_C_findIndex (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_eq_eq x1 cd cs) x2 cd cs) cd cs

nd_C_elemIndex :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int)
nd_C_elemIndex x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C_findIndex (let s1 = leftSupply s2
                                            s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) x2 s1 cd cs)) s3 cd cs))

d_C_elemIndices :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C_elemIndices x1 x2 cd cs = d_C_findIndices (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_eq_eq x1 cd cs) x2 cd cs)

nd_C_elemIndices :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)
nd_C_elemIndices x1 x2 s cd cs = let s2 = s
  in s2 `seq` wrapNX id (nd_C_findIndices (let s1 = leftSupply s2
                                               s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) x2 s1 cd cs)))

d_C_find :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C_find x1 cd cs = Curry_Prelude.d_OP_dot Curry_Maybe.d_C_listToMaybe
  (Curry_Prelude.d_C_filter x1) cd cs

nd_C_find :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Maybe t0)
nd_C_find x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id Curry_Maybe.d_C_listToMaybe)
  (wrapNX id (Curry_Prelude.nd_C_filter x1)) s0 cd cs

d_C_findIndex :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int
d_C_findIndex x1 cd cs = Curry_Prelude.d_OP_dot Curry_Maybe.d_C_listToMaybe
  (d_C_findIndices x1) cd cs

nd_C_findIndex :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Maybe Curry_Prelude.C_Int)
nd_C_findIndex x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id Curry_Maybe.d_C_listToMaybe)
  (wrapNX id (nd_C_findIndices x1)) s0 cd cs

d_C_findIndices :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_findIndices x1 x2 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_findIndices_dot_uscore_hash_lambda3 x1)) Curry_Prelude.OP_List
  (Curry_Prelude.d_C_zip x2 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
  cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs

nd_C_findIndices :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
nd_C_findIndices x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_findIndices_dot_uscore_hash_lambda3 x1))) Curry_Prelude.OP_List
  (Curry_Prelude.d_C_zip x2 (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
  cd cs)) (Curry_Prelude.C_Int (0)) s0 cd cs) cd cs) s1 cd cs))

d_OP_findIndices_dot_uscore_hash_lambda3 :: forall t0 . (Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_OP_findIndices_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_plus_plus (d_C__case_26 x4
    x1 x5 (Curry_Prelude.d_C_apply x1 x4 cd cs) cd cs) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_findIndices_dot_uscore_hash_lambda3 x1 l x3 cd cs)
    (d_OP_findIndices_dot_uscore_hash_lambda3 x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_findIndices_dot_uscore_hash_lambda3 x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_findIndices_dot_uscore_hash_lambda3 x1 e x3 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.findIndices._#lambda3" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.findIndices._#lambda3" (showCons x2))

nd_OP_findIndices_dot_uscore_hash_lambda3 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 Curry_Prelude.C_Bool -> Curry_Prelude.OP_Tuple2 t0
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
nd_OP_findIndices_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_26 x4 x1 x5 (Curry_Prelude.nd_C_apply x1 x4
    s0 cd cs) s1 cd cs)) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_findIndices_dot_uscore_hash_lambda3 x1 l x3 s cd cs)
    (nd_OP_findIndices_dot_uscore_hash_lambda3 x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_findIndices_dot_uscore_hash_lambda3 x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_findIndices_dot_uscore_hash_lambda3 x1 e x3 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.findIndices._#lambda3" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.findIndices._#lambda3" (showCons x2))

d_C_nub :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_nub x1 x2 cd cs = d_C_nubBy (Curry_Prelude.d_OP_eq_eq x1 cd cs) x2 cd cs

nd_C_nub :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_nub x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_nubBy (Curry_Prelude.nd_OP_eq_eq x1 s0 cd cs) x2 s1
  cd cs))

d_C_nubBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_nubBy x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.OP_Cons x3 (d_C_nubBy x1
    (Curry_Prelude.d_C_filter (d_OP_nubBy_dot_uscore_hash_lambda5 x3 x1) x4 cd
    cs) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_nubBy x1 l cd cs)
    (d_C_nubBy x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_nubBy x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_nubBy x1 e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.nubBy" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.nubBy" (showCons x2))

nd_C_nubBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_nubBy x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Cons x3 (let s1 = leftSupply s2
                                              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_nubBy x1 (Curry_Prelude.nd_C_filter (wrapNX id
    (nd_OP_nubBy_dot_uscore_hash_lambda5 x3 x1)) x4 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_nubBy x1 l s cd cs)
    (nd_C_nubBy x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_nubBy x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_nubBy x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.nubBy" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.nubBy" (showCons x2))

d_OP_nubBy_dot_uscore_hash_lambda5 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_nubBy_dot_uscore_hash_lambda5 x1 x2 x3 cd cs = Curry_Prelude.d_C_not
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x1 cd cs) x3 cd cs) cd cs

nd_OP_nubBy_dot_uscore_hash_lambda5 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Func t0 (Func t0 Curry_Prelude.C_Bool) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_nubBy_dot_uscore_hash_lambda5 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_C_not (let s1 = leftSupply s2
                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x1
  s0 cd cs) x3 s1 cd cs)) cd cs

d_C_delete :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_delete x1 cd cs = acceptCs id (d_C_deleteBy (Curry_Prelude.d_OP_eq_eq x1 cd
  cs))

nd_C_delete :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> IDSupply -> Cover
  -> ConstStore -> Func t0 (Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0))
nd_C_delete x1 s cd cs = let s0 = s
  in s0 `seq` wrapDX (wrapNX id) (acceptCs id (nd_C_deleteBy
  (Curry_Prelude.nd_OP_eq_eq x1 s0 cd cs)))

d_C_deleteBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_deleteBy x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_25 x4 x2 x1 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x2 cd cs) x4 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_deleteBy x1 x2 l cd
    cs) (d_C_deleteBy x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_deleteBy x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_deleteBy x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.deleteBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.deleteBy" (showCons x3))

nd_C_deleteBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_deleteBy x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_25 x4 x2 x1 x5 (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x2 s0 cd cs) x4 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_deleteBy x1 x2 l s cd
    cs) (nd_C_deleteBy x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_deleteBy x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_deleteBy x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.deleteBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.deleteBy" (showCons x3))

d_OP_backslash_backslash :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_backslash_backslash x1 x2 x3 cd cs = Curry_Prelude.d_C_foldl (acceptCs id
  (Curry_Prelude.d_C_flip (d_C_delete x1 cd cs))) x2 x3 cd cs

nd_OP_backslash_backslash :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_OP_backslash_backslash x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldl (wrapDX (wrapNX id) (acceptCs
  id (Curry_Prelude.nd_C_flip (nd_C_delete x1 s0 cd cs)))) x2 x3 s1 cd cs))

d_C_union :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_union x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> x3
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_24 x3 x4 x1 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x1 x4 cd cs) x3 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_union x1 l x3 cd cs)
    (d_C_union x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_union x1 z
    x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_union x1 e x3 cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.union" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.union" (showCons x2))

nd_C_union :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_union x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> x3
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_24 x3 x4 x1 x5 (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem x1
    x4 s0 cd cs) x3 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_union x1 l x3 s cd
    cs) (nd_C_union x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_union x1 z
    x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_union x1 e x3 s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.union" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.union" (showCons x2))

d_C_unionBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_unionBy x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.d_C_foldl (acceptCs id (Curry_Prelude.d_C_flip (acceptCs id
  (d_C_deleteBy x1)))) (d_C_nubBy x1 x3 cd cs) x2 cd cs) cd cs

nd_C_unionBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_unionBy x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus x2 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldl (wrapDX (wrapNX id) (acceptCs
  id (Curry_Prelude.nd_C_flip (wrapDX (wrapNX id) (acceptCs id (nd_C_deleteBy
  x1)))))) (nd_C_nubBy x1 x3 s0 cd cs) x2 s1 cd cs)) cd cs

d_C_intersect :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_intersect x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_23 x3 x4 x1 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x1 x4 cd cs) x3 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_intersect x1 l x3 cd
    cs) (d_C_intersect x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_intersect x1
    z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_intersect x1 e x3
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.intersect"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.intersect" (showCons x2))

nd_C_intersect :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_intersect x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_23 x3 x4 x1 x5 (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem x1
    x4 s0 cd cs) x3 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_intersect x1 l x3 s
    cd cs) (nd_C_intersect x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_intersect
    x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_intersect x1 e x3 s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.intersect"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.intersect" (showCons x2))

d_C_intersectBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_intersectBy x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_22 x2 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_intersectBy x1 l x3 cd
    cs) (d_C_intersectBy x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_intersectBy
    x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_intersectBy x1 e x3
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.intersectBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.intersectBy" (showCons x2))

nd_C_intersectBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_intersectBy x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_22 x2 x1 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_intersectBy x1 l x3 s
    cd cs) (nd_C_intersectBy x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_intersectBy
    x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_intersectBy x1 e x3 s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.intersectBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.intersectBy" (showCons x2))

d_OP_intersectBy_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> (t0 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_OP_intersectBy_dot_uscore_hash_lambda6 x1 x2 x3 cd cs = d_C__case_21 x1 x3 x2
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any (Curry_Prelude.d_C_apply x2 x3
  cd cs) cd cs) x1 cd cs) cd cs

nd_OP_intersectBy_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Func t0 (Func t0 Curry_Prelude.C_Bool)
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_intersectBy_dot_uscore_hash_lambda6 x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_21 x1 x3 x2 (let s3 = leftSupply s4
                                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_any (Curry_Prelude.nd_C_apply x2 x3
  s0 cd cs) s1 cd cs)) x1 s3 cd cs)) s5 cd cs))

d_C_intersperse :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_intersperse x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_20 x1 x3 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_intersperse x1 l cd
    cs) (d_C_intersperse x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_intersperse
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_intersperse x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.intersperse"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.intersperse" (showCons x2))

d_C_intercalate :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_intercalate x1 x2 cd cs = Curry_Prelude.d_C_concat (d_C_intersperse x1 x2 cd
  cs) cd cs

d_C_transpose :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C_transpose x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_19 x3 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_transpose l cd cs)
    (d_C_transpose r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_transpose z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_transpose e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.transpose"
    [show x1] info)
  _ -> failCons cd (consFail "List.transpose" (showCons x1))

d_C_diagonal :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_diagonal cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_concat
  (Curry_Prelude.d_C_foldr (acceptCs id d_OP_diagonal_dot_diags_dot_76)
  Curry_Prelude.OP_List) cd cs

d_OP_diagonal_dot_merge_dot_76 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_OP_diagonal_dot_merge_dot_76 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_18 x4 x3 x1 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_diagonal_dot_merge_dot_76 l x2 cd cs) (d_OP_diagonal_dot_merge_dot_76
    r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_diagonal_dot_merge_dot_76 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_diagonal_dot_merge_dot_76 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.diagonal.merge.76" [show x1, show x2] info)
  _ -> failCons cd (consFail "List.diagonal.merge.76" (showCons x1))

d_OP_diagonal_dot_diags_dot_76 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_OP_diagonal_dot_diags_dot_76 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3
    Curry_Prelude.OP_List) (d_OP_diagonal_dot_merge_dot_76 x4 x2 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_diagonal_dot_diags_dot_76 l x2 cd cs) (d_OP_diagonal_dot_diags_dot_76
    r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_diagonal_dot_diags_dot_76 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_diagonal_dot_diags_dot_76 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.diagonal.diags.76" [show x1, show x2] info)
  _ -> failCons cd (consFail "List.diagonal.diags.76" (showCons x1))

d_C_permutations :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_permutations x1 cd cs = Curry_Prelude.OP_Cons x1
  (d_OP_permutations_dot_perms_dot_90 x1 Curry_Prelude.OP_List cd cs)

d_OP_permutations_dot_perms_dot_90 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_permutations_dot_perms_dot_90 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95 x3 x4))
    (d_OP_permutations_dot_perms_dot_90 x4 (Curry_Prelude.OP_Cons x3 x2) cd cs)
    (d_C_permutations x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_permutations_dot_perms_dot_90 l x2 cd cs)
    (d_OP_permutations_dot_perms_dot_90 r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_permutations_dot_perms_dot_90 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_permutations_dot_perms_dot_90 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.permutations.perms.90" [show x1, show x2] info)
  _ -> failCons cd (consFail "List.permutations.perms.90" (showCons x1))

d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> (Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> t1) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1)
d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 x4 x5 cd cs =
  case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 x5
  Curry_Prelude.OP_Cons x6 x7 -> let x8 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95
                                       x1 x2 (Curry_Prelude.d_OP_dot x3
                                       (acceptCs id (Curry_Prelude.OP_Cons x6))
                                       cd cs) x7 x5 cd cs
                                     x9 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
                                       x8 cd cs
                                     x10 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
                                       x8 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x6 x9)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x3 (Curry_Prelude.OP_Cons x1
    (Curry_Prelude.OP_Cons x6 x9)) cd cs) x10)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 l x5
    cd cs) (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2
    x3 r x5 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 z x5
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 e x5
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.permutations.perms.90.interleave'.95" [show x1, show x2, show x3, show
    x4, show x5] info)
  _ -> failCons cd (consFail "List.permutations.perms.90.interleave'.95"
    (showCons x4))

nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Func (Curry_Prelude.OP_List t0) t1
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1)
nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 x4 x5 s cd cs =
  case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 x5
  Curry_Prelude.OP_Cons x6 x7 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` (let x8 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq`
                                 nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95
                                 x1 x2 (Curry_Prelude.nd_OP_dot x3 (wrapDX id
                                 (acceptCs id (Curry_Prelude.OP_Cons x6))) s0 cd
                                 cs) x7 x5 s1 cd cs)
                               x9 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
                                 x8 cd cs
                               x10 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
                                 x8 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x6 x9)
    (Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x3 (Curry_Prelude.OP_Cons
    x1 (Curry_Prelude.OP_Cons x6 x9)) s3 cd cs) x10))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 l
    x5 s cd cs) (nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95
    x1 x2 x3 r x5 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 z x5
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2 x3 e
    x5 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.permutations.perms.90.interleave'.95" [show x1, show x2, show x3, show
    x4, show x5] info)
  _ -> failCons cd (consFail "List.permutations.perms.90.interleave'.95"
    (showCons x4))

d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
    l cd cs)
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP2_hash_us
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.permutations.perms.90.interleave'.95._#selFP2#us" [show x1] info)
  _ -> failCons cd (consFail
    "List.permutations.perms.90.interleave'.95._#selFP2#us" (showCons x1))

d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
    l cd cs)
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95_dot_uscore_hash_selFP3_hash_zs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.permutations.perms.90.interleave'.95._#selFP3#zs" [show x1] info)
  _ -> failCons cd (consFail
    "List.permutations.perms.90.interleave'.95._#selFP3#zs" (showCons x1))

d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95 x1 x2 x3 x4 cd cs =
  let x5 = d_OP_permutations_dot_perms_dot_90_dot_interleave_tick_dot_95 x1 x2
        Curry_Prelude.d_C_id x3 x4 cd cs
  in d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs
  x5 cd cs

d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs
    l cd cs)
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_permutations_dot_perms_dot_90_dot_interleave_dot_95_dot_uscore_hash_selFP5_hash_zs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.permutations.perms.90.interleave.95._#selFP5#zs" [show x1] info)
  _ -> failCons cd (consFail
    "List.permutations.perms.90.interleave.95._#selFP5#zs" (showCons x1))

d_C_partition :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
d_C_partition x1 x2 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_partition_dot_select_dot_109 x1)) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x2 cd cs

nd_C_partition :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
nd_C_partition x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_partition_dot_select_dot_109 x1))) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_List Curry_Prelude.OP_List) x2 s0 cd cs

d_OP_partition_dot_select_dot_109 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  t0) (Curry_Prelude.OP_List t0)
d_OP_partition_dot_select_dot_109 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_17 x2 x1 x5 x4
    (Curry_Prelude.d_C_apply x1 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_partition_dot_select_dot_109 x1 x2 l cd cs)
    (d_OP_partition_dot_select_dot_109 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_partition_dot_select_dot_109 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_partition_dot_select_dot_109 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.partition.select.109" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.partition.select.109" (showCons x3))

nd_OP_partition_dot_select_dot_109 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 Curry_Prelude.C_Bool -> t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
nd_OP_partition_dot_select_dot_109 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_17 x2 x1 x5 x4 (Curry_Prelude.nd_C_apply x1
    x2 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_partition_dot_select_dot_109 x1 x2 l s cd cs)
    (nd_OP_partition_dot_select_dot_109 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_partition_dot_select_dot_109 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_partition_dot_select_dot_109 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.partition.select.109" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.partition.select.109" (showCons x3))

d_C_group :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C_group x1 cd cs = d_C_groupBy (Curry_Prelude.d_OP_eq_eq x1 cd cs)

nd_C_group :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))
nd_C_group x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_C_groupBy (Curry_Prelude.nd_OP_eq_eq x1 s0 cd cs))

d_C_groupBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C_groupBy x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_C_span
                                       (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
                                       cd cs
                                     x6 = d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys
                                       x5 cd cs
                                     x7 = d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs
                                       x5 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3 x6) (d_C_groupBy x1 x7 cd
    cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_groupBy x1 l cd cs)
    (d_C_groupBy x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_groupBy x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_groupBy x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.groupBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.groupBy" (showCons x2))

nd_C_groupBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C_groupBy x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` (let x5 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_span
                                 (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) x4 s1
                                 cd cs)
                               x6 = d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys
                                 x5 cd cs
                               x7 = d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs
                                 x5 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3 x6) (nd_C_groupBy x1 x7
    s3 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_groupBy x1 l s cd cs)
    (nd_C_groupBy x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_groupBy x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_groupBy x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.groupBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.groupBy" (showCons x2))

d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys l cd cs)
    (d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_groupBy_dot_uscore_hash_selFP7_hash_ys e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.groupBy._#selFP7#ys" [show x1] info)
  _ -> failCons cd (consFail "List.groupBy._#selFP7#ys" (showCons x1))

d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs l cd cs)
    (d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_groupBy_dot_uscore_hash_selFP8_hash_zs e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.groupBy._#selFP8#zs" [show x1] info)
  _ -> failCons cd (consFail "List.groupBy._#selFP8#zs" (showCons x1))

d_C_splitOn :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C_splitOn x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "splitOn called with an empty pattern") cd cs
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_16 x2 x3 x1 x4 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitOn x1 l x3 cd cs)
    (d_C_splitOn x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_splitOn x1 z
    x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_splitOn x1 e x3 cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.splitOn"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.splitOn" (showCons x2))

nd_C_splitOn :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C_splitOn x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "splitOn called with an empty pattern") cd cs
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_16 x2 x3 x1 x4 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_splitOn x1 l x3 s cd
    cs) (nd_C_splitOn x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_splitOn x1
    z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_splitOn x1 e x3 s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.splitOn"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.splitOn" (showCons x2))

d_OP_splitOn_dot_go_dot_129 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_splitOn_dot_go_dot_129 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_15 x4 x2 x3 x6 x1 x5 (d_C_isPrefixOf
    x3 x2 x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_splitOn_dot_go_dot_129 x1 x2 x3 l cd cs) (d_OP_splitOn_dot_go_dot_129
    x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_splitOn_dot_go_dot_129 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_splitOn_dot_go_dot_129 x1 x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.splitOn.go.129" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "List.splitOn.go.129" (showCons x4))

nd_OP_splitOn_dot_go_dot_129 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_15 x4 x2 x3 x6 x1 x5 (nd_C_isPrefixOf x3 x2
    x4 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 l s cd cs)
    (nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.splitOn.go.129" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "List.splitOn.go.129" (showCons x4))

d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs l cd cs)
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.splitOn.go.129._#selFP10#zs" [show x1] info)
  _ -> failCons cd (consFail "List.splitOn.go.129._#selFP10#zs" (showCons x1))

d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x3
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss l cd cs)
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.splitOn.go.129._#selFP11#zss" [show x1] info)
  _ -> failCons cd (consFail "List.splitOn.go.129._#selFP11#zss" (showCons x1))

d_C_split :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_split x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_13 x3 x1 x4 (Curry_Prelude.d_C_apply
    x1 x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_split x1 l cd cs)
    (d_C_split x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_split x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_split x1 e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.split" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.split" (showCons x2))

nd_C_split :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C_split x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_13 x3 x1 x4 (Curry_Prelude.nd_C_apply x1 x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_split x1 l s cd cs)
    (nd_C_split x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_split x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_split x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.split" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.split" (showCons x2))

d_OP_split_dot_uscore_hash_selFP13_hash_ys :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_OP_split_dot_uscore_hash_selFP13_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_split_dot_uscore_hash_selFP13_hash_ys l cd cs)
    (d_OP_split_dot_uscore_hash_selFP13_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_split_dot_uscore_hash_selFP13_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_split_dot_uscore_hash_selFP13_hash_ys e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.split._#selFP13#ys" [show x1] info)
  _ -> failCons cd (consFail "List.split._#selFP13#ys" (showCons x1))

d_OP_split_dot_uscore_hash_selFP14_hash_yss :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_split_dot_uscore_hash_selFP14_hash_yss x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x3
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_split_dot_uscore_hash_selFP14_hash_yss l cd cs)
    (d_OP_split_dot_uscore_hash_selFP14_hash_yss r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_split_dot_uscore_hash_selFP14_hash_yss z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_split_dot_uscore_hash_selFP14_hash_yss e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.split._#selFP14#yss" [show x1] info)
  _ -> failCons cd (consFail "List.split._#selFP14#yss" (showCons x1))

d_C_inits :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_inits x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    (Curry_Prelude.d_C_map (acceptCs id (Curry_Prelude.OP_Cons x2)) (d_C_inits
    x3 cd cs) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_inits l cd cs)
    (d_C_inits r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_inits z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_inits e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.inits" [show
    x1] info)
  _ -> failCons cd (consFail "List.inits" (showCons x1))

d_C_tails :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_tails x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> Curry_Prelude.OP_Cons x1 (d_C_tails x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_tails l cd cs)
    (d_C_tails r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_tails z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_tails e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.tails" [show
    x1] info)
  _ -> failCons cd (consFail "List.tails" (showCons x1))

d_C_replace :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_replace x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_11 x2 x5 x1 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
    x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_replace x1 x2 l cd cs)
    (d_C_replace x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_replace x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_replace x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.replace"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.replace" (showCons x3))

d_C_isPrefixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isPrefixOf x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_True
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_9 x5 x1 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_isPrefixOf x1 l x3 cd
    cs) (d_C_isPrefixOf x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_isPrefixOf
    x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_isPrefixOf x1 e x3
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.isPrefixOf"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.isPrefixOf" (showCons x2))

nd_C_isPrefixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_isPrefixOf x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_True
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_9 x5 x1 x4 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_isPrefixOf x1 l x3 s
    cd cs) (nd_C_isPrefixOf x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_isPrefixOf
    x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_isPrefixOf x1 e x3 s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.isPrefixOf"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.isPrefixOf" (showCons x2))

d_C_isSuffixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSuffixOf x1 x2 x3 cd cs = d_C_isPrefixOf x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_reverse cd cs) x2 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_reverse cd cs) x3 cd cs) cd cs

nd_C_isSuffixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_isSuffixOf x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_isPrefixOf x1
  (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Prelude.d_C_reverse cd cs)) x2 s0
  cd cs) (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Prelude.d_C_reverse cd cs))
  x3 s1 cd cs) s2 cd cs))))

d_C_isInfixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isInfixOf x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
  (d_C_isPrefixOf x1 x2) cd cs) (d_C_tails x3 cd cs) cd cs

nd_C_isInfixOf :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_isInfixOf x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_any (wrapNX
  id (nd_C_isPrefixOf x1 x2)) s0 cd cs) (d_C_tails x3 cd cs) s1 cd cs))

d_C_sortBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_sortBy x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id (d_C_insertBy x1))
  Curry_Prelude.OP_List

nd_C_sortBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_C_sortBy x1 s cd cs = wrapNX id (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id)
  (acceptCs id (nd_C_insertBy x1))) Curry_Prelude.OP_List)

d_C_insertBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_insertBy x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_8 x4 x2 x1 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x2 cd cs) x4 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_insertBy x1 x2 l cd
    cs) (d_C_insertBy x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_insertBy x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_insertBy x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.insertBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.insertBy" (showCons x3))

nd_C_insertBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Bool) -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_insertBy x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_8 x4 x2 x1 x5 (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x2 s0 cd cs) x4 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_insertBy x1 x2 l s cd
    cs) (nd_C_insertBy x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_insertBy x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_insertBy x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.insertBy"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.insertBy" (showCons x3))

d_C_last :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_last x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_7 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_last l cd cs)
    (d_C_last r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_last z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_last e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.last" [show
    x1] info)
  _ -> failCons cd (consFail "List.last" (showCons x1))

d_C_init :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_init x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_6 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_init l cd cs)
    (d_C_init r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_init z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_init e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.init" [show
    x1] info)
  _ -> failCons cd (consFail "List.init" (showCons x1))

d_C_sum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Num t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_sum x1 x2 cd cs = Curry_Prelude.d_C_foldl (Curry_Prelude.d_OP_plus x1 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x1 cd cs)
  (Curry_Prelude.C_Int (0)) cd cs) x2 cd cs

nd_C_sum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Num t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_sum x1 x2 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_foldl
  (Curry_Prelude.nd_OP_plus x1 s0 cd cs) (let s2 = leftSupply s3
                                              s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt x1
  s1 cd cs) (Curry_Prelude.C_Int (0)) s2 cd cs)) x2 s4 cd cs))))

d_C_product :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Num t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_product x1 x2 cd cs = Curry_Prelude.d_C_foldl (Curry_Prelude.d_OP_star x1 cd
  cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x1 cd cs)
  (Curry_Prelude.C_Int (1)) cd cs) x2 cd cs

nd_C_product :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Num t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_product x1 x2 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_foldl
  (Curry_Prelude.nd_OP_star x1 s0 cd cs) (let s2 = leftSupply s3
                                              s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt x1
  s1 cd cs) (Curry_Prelude.C_Int (1)) s2 cd cs)) x2 s4 cd cs))))

d_C_maximum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Ord t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_maximum x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_foldl1 (Curry_Prelude.d_C_max
    x1 cd cs) x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_maximum x1 l cd cs)
    (d_C_maximum x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_maximum x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_maximum x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.maximum"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.maximum" (showCons x2))

nd_C_maximum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Ord t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_maximum x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldl1 (Curry_Prelude.nd_C_max x1
    s0 cd cs) x2 s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_maximum x1 l s cd cs)
    (nd_C_maximum x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_maximum x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_maximum x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.maximum"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.maximum" (showCons x2))

d_C_maximumBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Ordering)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_maximumBy x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_foldl1 (acceptCs id
    (d_OP_maximumBy_dot_maxBy_dot_204 x1)) x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_maximumBy x1 l cd cs)
    (d_C_maximumBy x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_maximumBy x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_maximumBy x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.maximumBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.maximumBy" (showCons x2))

nd_C_maximumBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Ordering) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_maximumBy x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_foldl1 (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_maximumBy_dot_maxBy_dot_204 x1))) x2 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_maximumBy x1 l s cd
    cs) (nd_C_maximumBy x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_maximumBy
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_maximumBy x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.maximumBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.maximumBy" (showCons x2))

d_OP_maximumBy_dot_maxBy_dot_204 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Ordering) -> t0 -> t0 -> Cover -> ConstStore -> t0
d_OP_maximumBy_dot_maxBy_dot_204 x1 x2 x3 cd cs = d_C__case_5 x3 x2 x1
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x2 cd cs) x3 cd cs) cd cs

nd_OP_maximumBy_dot_maxBy_dot_204 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 (Func t0 Curry_Prelude.C_Ordering) -> t0 -> t0 -> IDSupply
  -> Cover -> ConstStore -> t0
nd_OP_maximumBy_dot_maxBy_dot_204 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_5 x3 x2 x1 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs) x3 s1 cd cs)) s3 cd cs))

d_C_minimum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Ord t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_minimum x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_foldl1 (Curry_Prelude.d_C_min
    x1 cd cs) x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_minimum x1 l cd cs)
    (d_C_minimum x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_minimum x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_minimum x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.minimum"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.minimum" (showCons x2))

nd_C_minimum :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Ord t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_minimum x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldl1 (Curry_Prelude.nd_C_min x1
    s0 cd cs) x2 s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_minimum x1 l s cd cs)
    (nd_C_minimum x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_minimum x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_minimum x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.minimum"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.minimum" (showCons x2))

d_C_minimumBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Ordering)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_minimumBy x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_foldl1 (acceptCs id
    (d_OP_minimumBy_dot_minBy_dot_219 x1)) x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_minimumBy x1 l cd cs)
    (d_C_minimumBy x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_minimumBy x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_minimumBy x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.minimumBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.minimumBy" (showCons x2))

nd_C_minimumBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0
  Curry_Prelude.C_Ordering) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_minimumBy x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_foldl1 (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_minimumBy_dot_minBy_dot_219 x1))) x2 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_minimumBy x1 l s cd
    cs) (nd_C_minimumBy x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_minimumBy
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_minimumBy x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.minimumBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "List.minimumBy" (showCons x2))

d_OP_minimumBy_dot_minBy_dot_219 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Ordering) -> t0 -> t0 -> Cover -> ConstStore -> t0
d_OP_minimumBy_dot_minBy_dot_219 x1 x2 x3 cd cs = d_C__case_4 x3 x2 x1
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x2 cd cs) x3 cd cs) cd cs

nd_OP_minimumBy_dot_minBy_dot_219 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 (Func t0 Curry_Prelude.C_Ordering) -> t0 -> t0 -> IDSupply
  -> Cover -> ConstStore -> t0
nd_OP_minimumBy_dot_minBy_dot_219 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_4 x3 x2 x1 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs) x3 s1 cd cs)) s3 cd cs))

d_C_scanl :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t0
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_scanl x1 x2 x3 cd cs = Curry_Prelude.OP_Cons x2 (d_C__case_3 x2 x1 x3 cd cs)

nd_C_scanl :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func t0 (Func t1 t0) -> t0 -> Curry_Prelude.OP_List t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_scanl x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Cons x2 (nd_C__case_3 x2 x1 x3 s0 cd cs)

d_C_scanl1 :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C_scanl1 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C_scanl x1 x3 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanl1 x1 l cd cs)
    (d_C_scanl1 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scanl1 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_scanl1 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanl1" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.scanl1" (showCons x2))

nd_C_scanl1 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0 t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_scanl1 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C_scanl x1 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_scanl1 x1 l s cd cs)
    (nd_C_scanl1 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_scanl1 x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_scanl1 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanl1" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.scanl1" (showCons x2))

d_C_scanr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t1) -> t1
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_scanr x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = d_C_scanr x1 x2 x5 cd cs
                                     x7 = d_OP_scanr_dot_uscore_hash_selFP16_hash_qs
                                       x6 cd cs
                                     x8 = d_OP_scanr_dot_uscore_hash_selFP17_hash_q
                                       x6 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x1 x4 cd cs) x8 cd cs) x7
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanr x1 x2 l cd cs)
    (d_C_scanr x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scanr x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_scanr x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanr" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.scanr" (showCons x3))

nd_C_scanr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Func t1 t1) -> t1 -> Curry_Prelude.OP_List t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
nd_C_scanr x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x6 = nd_C_scanr x1 x2 x5 s0 cd cs
                               x7 = d_OP_scanr_dot_uscore_hash_selFP16_hash_qs
                                 x6 cd cs
                               x8 = d_OP_scanr_dot_uscore_hash_selFP17_hash_q x6
                                 cd cs
    in Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                  s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s1 cd cs) x8 s2 cd cs)) x7)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_scanr x1 x2 l s cd
    cs) (nd_C_scanr x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_scanr x1 x2
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_scanr x1 x2 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanr" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.scanr" (showCons x3))

d_OP_scanr_dot_uscore_hash_selFP16_hash_qs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_OP_scanr_dot_uscore_hash_selFP16_hash_qs x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scanr_dot_uscore_hash_selFP16_hash_qs l cd cs)
    (d_OP_scanr_dot_uscore_hash_selFP16_hash_qs r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scanr_dot_uscore_hash_selFP16_hash_qs z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_scanr_dot_uscore_hash_selFP16_hash_qs e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.scanr._#selFP16#qs" [show x1] info)
  _ -> failCons cd (consFail "List.scanr._#selFP16#qs" (showCons x1))

d_OP_scanr_dot_uscore_hash_selFP17_hash_q :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_OP_scanr_dot_uscore_hash_selFP17_hash_q x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scanr_dot_uscore_hash_selFP17_hash_q l cd cs)
    (d_OP_scanr_dot_uscore_hash_selFP17_hash_q r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scanr_dot_uscore_hash_selFP17_hash_q z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_scanr_dot_uscore_hash_selFP17_hash_q e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.scanr._#selFP17#q" [show x1] info)
  _ -> failCons cd (consFail "List.scanr._#selFP17#q" (showCons x1))

d_C_scanr1 :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C_scanr1 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_2 x1 x3 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanr1 x1 l cd cs)
    (d_C_scanr1 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scanr1 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_scanr1 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanr1" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.scanr1" (showCons x2))

nd_C_scanr1 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0 t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_scanr1 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_2 x1 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_scanr1 x1 l s cd cs)
    (nd_C_scanr1 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_scanr1 x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_scanr1 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.scanr1" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "List.scanr1" (showCons x2))

d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs l cd cs)
    (d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.scanr1._#selFP19#qs" [show x1] info)
  _ -> failCons cd (consFail "List.scanr1._#selFP19#qs" (showCons x1))

d_OP_scanr1_dot_uscore_hash_selFP20_hash_q :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_OP_scanr1_dot_uscore_hash_selFP20_hash_q x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scanr1_dot_uscore_hash_selFP20_hash_q l cd cs)
    (d_OP_scanr1_dot_uscore_hash_selFP20_hash_q r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scanr1_dot_uscore_hash_selFP20_hash_q z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_scanr1_dot_uscore_hash_selFP20_hash_q e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "List.scanr1._#selFP20#q" [show x1] info)
  _ -> failCons cd (consFail "List.scanr1._#selFP20#q" (showCons x1))

d_C_mapAccumL :: forall t1 t0 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 t2) -> t0 -> Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  t2)
d_C_mapAccumL x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply x1 x2 cd cs) x4
                                       cd cs
                                     x7 = d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick
                                       x6 cd cs
                                     x8 = d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y
                                       x6 cd cs
                                     x9 = d_C_mapAccumL x1 x7 x5 cd cs
                                     x10 = d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick
                                       x9 cd cs
                                     x11 = d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys
                                       x9 cd cs
    in Curry_Prelude.OP_Tuple2 x10 (Curry_Prelude.OP_Cons x8 x11)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapAccumL x1 x2 l cd
    cs) (d_C_mapAccumL x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapAccumL x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_mapAccumL x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.mapAccumL"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.mapAccumL" (showCons x3))

nd_C_mapAccumL :: forall t1 t0 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Func t0 (Func t1 (Curry_Prelude.OP_Tuple2 t0
  t2)) -> t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t2)
nd_C_mapAccumL x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` (let x6 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                                 (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs) x4 s1
                                 cd cs)
                               x7 = d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick
                                 x6 cd cs
                               x8 = d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y
                                 x6 cd cs
                               x9 = nd_C_mapAccumL x1 x7 x5 s3 cd cs
                               x10 = d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick
                                 x9 cd cs
                               x11 = d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys
                                 x9 cd cs
    in Curry_Prelude.OP_Tuple2 x10 (Curry_Prelude.OP_Cons x8 x11))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapAccumL x1 x2 l s
    cd cs) (nd_C_mapAccumL x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapAccumL
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_mapAccumL x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.mapAccumL"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.mapAccumL" (showCons x3))

d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover -> ConstStore -> t0
d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick l cd cs)
    (d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumL_dot_uscore_hash_selFP25_hash_s_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumL._#selFP25#s'" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumL._#selFP25#s'" (showCons x1))

d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover -> ConstStore -> t1
d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y l cd cs)
    (d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumL_dot_uscore_hash_selFP26_hash_y e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumL._#selFP26#y" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumL._#selFP26#y" (showCons x1))

d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1) -> Cover
  -> ConstStore -> t0
d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick l cd cs)
    (d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumL_dot_uscore_hash_selFP23_hash_s_tick_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumL._#selFP23#s''" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumL._#selFP23#s''" (showCons x1))

d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1
d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys l cd cs)
    (d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumL_dot_uscore_hash_selFP24_hash_ys e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumL._#selFP24#ys" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumL._#selFP24#ys" (showCons x1))

d_C_mapAccumR :: forall t1 t0 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 t2) -> t0 -> Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  t2)
d_C_mapAccumR x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = d_C_mapAccumR x1 x2 x5 cd cs
                                     x7 = d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick
                                       x6 cd cs
                                     x8 = d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys
                                       x6 cd cs
                                     x9 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply x1 x7 cd cs) x4
                                       cd cs
                                     x10 = d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick
                                       x9 cd cs
                                     x11 = d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y
                                       x9 cd cs
    in Curry_Prelude.OP_Tuple2 x10 (Curry_Prelude.OP_Cons x11 x8)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapAccumR x1 x2 l cd
    cs) (d_C_mapAccumR x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapAccumR x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_mapAccumR x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.mapAccumR"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.mapAccumR" (showCons x3))

nd_C_mapAccumR :: forall t1 t0 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Func t0 (Func t1 (Curry_Prelude.OP_Tuple2 t0
  t2)) -> t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t2)
nd_C_mapAccumR x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x6 = nd_C_mapAccumR x1 x2 x5 s0 cd cs
                               x7 = d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick
                                 x6 cd cs
                               x8 = d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys
                                 x6 cd cs
                               x9 = let s2 = leftSupply s3
                                        s1 = rightSupply s3
                                 in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
                                 (Curry_Prelude.nd_C_apply x1 x7 s1 cd cs) x4 s2
                                 cd cs)
                               x10 = d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick
                                 x9 cd cs
                               x11 = d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y
                                 x9 cd cs
    in Curry_Prelude.OP_Tuple2 x10 (Curry_Prelude.OP_Cons x11 x8))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapAccumR x1 x2 l s
    cd cs) (nd_C_mapAccumR x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapAccumR
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C_mapAccumR x1 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.mapAccumR"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "List.mapAccumR" (showCons x3))

d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1) -> Cover
  -> ConstStore -> t0
d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick l cd cs)
    (d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumR_dot_uscore_hash_selFP31_hash_s_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumR._#selFP31#s'" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumR._#selFP31#s'" (showCons x1))

d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1
d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys l cd cs)
    (d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumR_dot_uscore_hash_selFP32_hash_ys e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumR._#selFP32#ys" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumR._#selFP32#ys" (showCons x1))

d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover -> ConstStore -> t0
d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick l cd cs)
    (d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumR_dot_uscore_hash_selFP29_hash_s_tick_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumR._#selFP29#s''" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumR._#selFP29#s''" (showCons x1))

d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover -> ConstStore -> t1
d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y l cd cs)
    (d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_mapAccumR_dot_uscore_hash_selFP30_hash_y e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "List.mapAccumR._#selFP30#y" [show x1] info)
  _ -> failCons cd (consFail "List.mapAccumR._#selFP30#y" (showCons x1))

d_C_cycle :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_cycle x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = Curry_Prelude.d_OP_plus_plus x1 x4 cd
                                       cs
    in x4
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_cycle l cd cs)
    (d_C_cycle r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_cycle z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_cycle e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List.cycle" [show
    x1] info)
  _ -> failCons cd (consFail "List.cycle" (showCons x1))

d_C_unfoldr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0)) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1
d_C_unfoldr x1 x2 cd cs = d_C__case_1 x2 x1 (Curry_Prelude.d_C_apply x1 x2 cd
  cs) cd cs

nd_C_unfoldr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0)) -> t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
nd_C_unfoldr x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_1 x2 x1 (Curry_Prelude.nd_C_apply x1 x2 s0 cd
  cs) s1 cd cs))

d_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t0 -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0)) -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1
d_C__case_1 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_Just x3 -> d_C__case_0 x1 x3 cd cs
  Curry_Prelude.C_Nothing -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_1 x2 x1 l cd cs)
    (d_C__case_1 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_1 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "List._case_1"
    [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_1" (showCons x4))

nd_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t0 -> Func t0 (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0))
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1
nd_C__case_1 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_Just x3 -> let s0 = s in s0 `seq` nd_C__case_0 x1 x3 s0 cd cs
  Curry_Prelude.C_Nothing -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_1 x2 x1 l s cd
    cs) (nd_C__case_1 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_1 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_1 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "List._case_1"
    [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_1" (showCons x4))

d_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0)) -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1
d_C__case_0 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Cons x4 (d_C_unfoldr x1 x5
    cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_0 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "List._case_0"
    [show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_0" (showCons x3))

nd_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t0 (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0))
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1
nd_C__case_0 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_unfoldr x1 x5 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x1 l s cd
    cs) (nd_C__case_0 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_0 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "List._case_0"
    [show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_0" (showCons x3))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let x7 = d_C_scanr1 x1 x4 cd cs
                                     x8 = d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs
                                       x7 cd cs
                                     x9 = d_OP_scanr1_dot_uscore_hash_selFP20_hash_q
                                       x7 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x1 x3 cd cs) x9 cd cs) x8
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x1 x3 l cd cs)
    (d_C__case_2 x1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_2 x1 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_2"
    [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "List._case_2" (showCons x4))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func t0 t0)
  -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_2 x1 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x7 = nd_C_scanr1 x1 x4 s0 cd cs
                               x8 = d_OP_scanr1_dot_uscore_hash_selFP19_hash_qs
                                 x7 cd cs
                               x9 = d_OP_scanr1_dot_uscore_hash_selFP20_hash_q
                                 x7 cd cs
    in Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                  s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s1 cd cs) x9 s2 cd cs)) x8)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_2 x1 x3 l s cd
    cs) (nd_C__case_2 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_2 x1
    x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_2 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_2"
    [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "List._case_2" (showCons x4))

d_C__case_3 :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> (t0 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_3 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C_scanl x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x2 cd cs) x4 cd cs) x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x2 x1 l cd cs)
    (d_C__case_3 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_3"
    [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_3" (showCons x3))

nd_C__case_3 :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> Func t0 (Func t1 t0) -> Curry_Prelude.OP_List t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_3 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C_scanl x1 (let s1 = leftSupply s2
                                             s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x2 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_3 x2 x1 l s cd
    cs) (nd_C__case_3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_3 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_3 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_3"
    [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_3" (showCons x3))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Ordering)
  -> Curry_Prelude.C_Ordering -> Cover -> ConstStore -> t0
d_C__case_4 x3 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_GT -> x3
  Curry_Prelude.C_LT -> x2
  Curry_Prelude.C_EQ -> x2
  Curry_Prelude.Choice_C_Ordering d i l r -> narrow d i (d_C__case_4 x3 x2 x1 l
    cd cs) (d_C__case_4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Ordering d i xs -> narrows cs d i (\z -> d_C__case_4
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Ordering d c e -> guardCons d c (d_C__case_4 x3 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Ordering d info -> failCons d (traceFail "List._case_4"
    [show x3, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_4" (showCons x4))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func t0
  (Func t0 Curry_Prelude.C_Ordering) -> Curry_Prelude.C_Ordering -> IDSupply
  -> Cover -> ConstStore -> t0
nd_C__case_4 x3 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_GT -> x3
  Curry_Prelude.C_LT -> x2
  Curry_Prelude.C_EQ -> x2
  Curry_Prelude.Choice_C_Ordering d i l r -> narrow d i (nd_C__case_4 x3 x2 x1 l
    s cd cs) (nd_C__case_4 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Ordering d i xs -> narrows cs d i (\z -> nd_C__case_4
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Ordering d c e -> guardCons d c (nd_C__case_4 x3 x2 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Ordering d info -> failCons d (traceFail "List._case_4"
    [show x3, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_4" (showCons x4))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Ordering)
  -> Curry_Prelude.C_Ordering -> Cover -> ConstStore -> t0
d_C__case_5 x3 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_GT -> x2
  Curry_Prelude.C_LT -> x3
  Curry_Prelude.C_EQ -> x3
  Curry_Prelude.Choice_C_Ordering d i l r -> narrow d i (d_C__case_5 x3 x2 x1 l
    cd cs) (d_C__case_5 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Ordering d i xs -> narrows cs d i (\z -> d_C__case_5
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Ordering d c e -> guardCons d c (d_C__case_5 x3 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Ordering d info -> failCons d (traceFail "List._case_5"
    [show x3, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_5" (showCons x4))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func t0
  (Func t0 Curry_Prelude.C_Ordering) -> Curry_Prelude.C_Ordering -> IDSupply
  -> Cover -> ConstStore -> t0
nd_C__case_5 x3 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_GT -> x2
  Curry_Prelude.C_LT -> x3
  Curry_Prelude.C_EQ -> x3
  Curry_Prelude.Choice_C_Ordering d i l r -> narrow d i (nd_C__case_5 x3 x2 x1 l
    s cd cs) (nd_C__case_5 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Ordering d i xs -> narrows cs d i (\z -> nd_C__case_5
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Ordering d c e -> guardCons d c (nd_C__case_5 x3 x2 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Ordering d info -> failCons d (traceFail "List._case_5"
    [show x3, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "List._case_5" (showCons x4))

d_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_6 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.OP_Cons x2 (d_C_init x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_6 x2 l cd cs)
    (d_C__case_6 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_6 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_6 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_6"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "List._case_6" (showCons x3))

d_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C__case_7 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x4 x5 -> d_C_last x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_7 x2 l cd cs)
    (d_C__case_7 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_7 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_7 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_7"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "List._case_7" (showCons x3))

d_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_8 x4 x2 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x4 x5)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x4 (d_C_insertBy x1 x2 x5 cd
    cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x4 x2 x1 x5 l
    cd cs) (d_C__case_8 x4 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x4 x2
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x4 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_8" [show
    x4, show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_8" (showCons x6))

nd_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func t0
  (Func t0 Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_8 x4 x2 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x4 x5)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_insertBy x1 x2 x5 s0 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_8 x4 x2 x1 x5 l
    s cd cs) (nd_C__case_8 x4 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_8 x4
    x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_8 x4 x2 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_8" [show
    x4, show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_8" (showCons x6))

d_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x5 x1 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    x1 cd cs) x4 cd cs) x6 cd cs) (d_C_isPrefixOf x1 x5 x7 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x5 x1 x4 l cd
    cs) (d_C__case_9 x5 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x5
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_9 x5 x1 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_9"
    [show x5, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "List._case_9" (showCons x3))

nd_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_9 x5 x1 x4 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x6 x7 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x4 s1 cd cs)) x6 s3 cd cs)) (nd_C_isPrefixOf x1 x5 x7 s5 cd cs) cd
    cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_9 x5 x1 x4 l s
    cd cs) (nd_C__case_9 x5 x1 x4 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_9 x5
    x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_9 x5 x1 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_9"
    [show x5, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "List._case_9" (showCons x3))

d_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> t0 -> t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_11 x2 x5 x1 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 x5
  Curry_Prelude.C_False -> d_C__case_10 x5 x2 x1 x4 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x2 x5 x1 x4 l
    cd cs) (d_C__case_11 x2 x5 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x2
    x5 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_11 x2 x5 x1 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_11"
    [show x2, show x5, show x1, show x4, show x6] info)
  _ -> failCons cd (consFail "List._case_11" (showCons x6))

d_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Int -> t0 -> t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_10 x5 x2 x1 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x4 (d_C_replace x1
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    x2 (Curry_Prelude.C_Int (1)) cd cs) x5 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x5 x2 x1 x4 l
    cd cs) (d_C__case_10 x5 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x5
    x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_10 x5 x2 x1 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_10"
    [show x5, show x2, show x1, show x4, show x6] info)
  _ -> failCons cd (consFail "List._case_10" (showCons x6))

d_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_13 x3 x1 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List (d_C_split
    x1 x4 cd cs)
  Curry_Prelude.C_False -> d_C__case_12 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x3 x1 x4 l cd
    cs) (d_C__case_13 x3 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x3
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_13 x3 x1 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_13"
    [show x3, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "List._case_13" (showCons x5))

nd_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
nd_C__case_13 x3 x1 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons Curry_Prelude.OP_List (nd_C_split x1 x4 s0
    cd cs)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_12 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x3 x1 x4 l s
    cd cs) (nd_C__case_13 x3 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x3
    x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_13 x3 x1 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_13"
    [show x3, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "List._case_13" (showCons x5))

d_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_12 x4 x1 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> let x5 = d_C_split x1 x4 cd cs
                              x6 = d_OP_split_dot_uscore_hash_selFP13_hash_ys x5
                                cd cs
                              x7 = d_OP_split_dot_uscore_hash_selFP14_hash_yss
                                x5 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3 x6) x7
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x4 x1 x3 l cd
    cs) (d_C__case_12 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_12 x4 x1 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_12"
    [show x4, show x1, show x3, show x8] info)
  _ -> failCons cd (consFail "List._case_12" (showCons x8))

nd_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Func t0 Curry_Prelude.C_Bool -> t0 -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_12 x4 x1 x3 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x5 = nd_C_split x1 x4 s0 cd cs
                     x6 = d_OP_split_dot_uscore_hash_selFP13_hash_ys x5 cd cs
                     x7 = d_OP_split_dot_uscore_hash_selFP14_hash_yss x5 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3 x6) x7)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x4 x1 x3 l s
    cd cs) (nd_C__case_12 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x4
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_12 x4 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_12"
    [show x4, show x1, show x3, show x8] info)
  _ -> failCons cd (consFail "List._case_12" (showCons x8))

d_C__case_15 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_15 x4 x2 x3 x6 x1 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    (d_OP_splitOn_dot_go_dot_129 x1 x2 x3 (Curry_Prelude.d_C_drop x1 x4 cd cs)
    cd cs)
  Curry_Prelude.C_False -> d_C__case_14 x6 x3 x2 x1 x5
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x4 x2 x3 x6 x1
    x5 l cd cs) (d_C__case_15 x4 x2 x3 x6 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x4
    x2 x3 x6 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_15 x4 x2 x3 x6 x1
    x5 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_15"
    [show x4, show x2, show x3, show x6, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "List._case_15" (showCons x7))

nd_C__case_15 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_15 x4 x2 x3 x6 x1 x5 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    (nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 (Curry_Prelude.d_C_drop x1 x4 cd cs)
    s0 cd cs)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_14 x6 x3 x2 x1 x5 (Curry_Prelude.d_C_otherwise cd cs)
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_15 x4 x2 x3 x6
    x1 x5 l s cd cs) (nd_C__case_15 x4 x2 x3 x6 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_15 x4
    x2 x3 x6 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_15 x4 x2 x3 x6
    x1 x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_15"
    [show x4, show x2, show x3, show x6, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "List._case_15" (showCons x7))

d_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C__case_14 x6 x3 x2 x1 x5 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> let x7 = d_OP_splitOn_dot_go_dot_129 x1 x2 x3 x6 cd cs
                              x8 = d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs
                                x7 cd cs
                              x9 = d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss
                                x7 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x5 x8) x9
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x6 x3 x2 x1 x5
    l cd cs) (d_C__case_14 x6 x3 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x6
    x3 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_14 x6 x3 x2 x1 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_14"
    [show x6, show x3, show x2, show x1, show x5, show x10] info)
  _ -> failCons cd (consFail "List._case_14" (showCons x10))

nd_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_14 x6 x3 x2 x1 x5 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x7 = nd_OP_splitOn_dot_go_dot_129 x1 x2 x3 x6 s0 cd cs
                     x8 = d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP10_hash_zs
                       x7 cd cs
                     x9 = d_OP_splitOn_dot_go_dot_129_dot_uscore_hash_selFP11_hash_zss
                       x7 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x5 x8) x9)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_14 x6 x3 x2 x1
    x5 l s cd cs) (nd_C__case_14 x6 x3 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_14 x6
    x3 x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_14 x6 x3 x2 x1
    x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_14"
    [show x6, show x3, show x2, show x1, show x5, show x10] info)
  _ -> failCons cd (consFail "List._case_14" (showCons x10))

d_C__case_16 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_16 x2 x3 x1 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> d_C_split (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_eq_eq x1 cd cs) x4 cd cs) x3 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> let x8 = Curry_Prelude.d_C_length x2 cd cs
    in d_OP_splitOn_dot_go_dot_129 x8 x2 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_16 x2 x3 x1 x4 l
    cd cs) (d_C__case_16 x2 x3 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_16 x2
    x3 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_16 x2 x3 x1 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_16"
    [show x2, show x3, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "List._case_16" (showCons x5))

nd_C__case_16 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_16 x2 x3 x1 x4 x5 s cd cs = case x5 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C_split (let s1 = leftSupply s2
                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x4 s1 cd cs)) x3 s3 cd cs))
  Curry_Prelude.OP_Cons x6 x7 -> let s0 = s
    in s0 `seq` (let x8 = Curry_Prelude.d_C_length x2 cd cs
    in nd_OP_splitOn_dot_go_dot_129 x8 x2 x1 x3 s0 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_16 x2 x3 x1 x4
    l s cd cs) (nd_C__case_16 x2 x3 x1 x4 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_16 x2
    x3 x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_16 x2 x3 x1 x4
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_16"
    [show x2, show x3, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "List._case_16" (showCons x5))

d_C__case_17 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0)
d_C__case_17 x2 x1 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x2 x4)
    x5
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons x2
    x5)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x2 x1 x5 x4 l
    cd cs) (d_C__case_17 x2 x1 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x2
    x1 x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x2 x1 x5 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_17"
    [show x2, show x1, show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "List._case_17" (showCons x6))

nd_C__case_17 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0)
nd_C__case_17 x2 x1 x5 x4 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x2 x4)
    x5
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons x2
    x5)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x2 x1 x5 x4 l
    s cd cs) (nd_C__case_17 x2 x1 x5 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x2
    x1 x5 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_17 x2 x1 x5 x4 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_17"
    [show x2, show x1, show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "List._case_17" (showCons x6))

d_C__case_18 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_18 x4 x3 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_map (Curry_Prelude.d_C_flip
    (acceptCs (acceptCs id) Curry_Prelude.OP_Cons) Curry_Prelude.OP_List) x1 cd
    cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x3
    x5) (d_OP_diagonal_dot_merge_dot_76 x4 x6 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x4 x3 x1 l cd
    cs) (d_C__case_18 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_18 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_18"
    [show x4, show x3, show x1, show x2] info)
  _ -> failCons cd (consFail "List._case_18" (showCons x2))

d_C__case_19 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C__case_19 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C_transpose x3 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x4
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_head x3 cd cs)) (d_C_transpose
    (Curry_Prelude.OP_Cons x5 (Curry_Prelude.d_C_map Curry_Prelude.d_C_tail x3
    cd cs)) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 x3 l cd cs)
    (d_C__case_19 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_19 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_19"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "List._case_19" (showCons x2))

d_C__case_20 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_20 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons
    x1 (d_C_intersperse x1 x4 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_20 x1 x3 l cd
    cs) (d_C__case_20 x1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_20 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_20 x1 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_20"
    [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "List._case_20" (showCons x4))

d_C__case_21 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_21 x1 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x1 x3 x2 l cd
    cs) (d_C__case_21 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_21 x1 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_21"
    [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "List._case_21" (showCons x4))

nd_C__case_21 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> t0 -> Func t0 (Func t0 Curry_Prelude.C_Bool) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_21 x1 x3 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_21 x1 x3 x2 l s
    cd cs) (nd_C__case_21 x1 x3 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_21 x1
    x3 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_21 x1 x3 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_21"
    [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "List._case_21" (showCons x4))

d_C__case_22 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_22 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_intersectBy_dot_uscore_hash_lambda6 x3
    x1) cd cs) x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x2 x1 l cd
    cs) (d_C__case_22 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_22 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_22"
    [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_22" (showCons x3))

nd_C__case_22 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Func t0 (Func t0 Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_22 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
    (wrapNX id (nd_OP_intersectBy_dot_uscore_hash_lambda6 x3 x1)) s0 cd cs) x2
    s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_22 x2 x1 l s cd
    cs) (nd_C__case_22 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_22 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_22 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "List._case_22"
    [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "List._case_22" (showCons x3))

d_C__case_23 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_23 x3 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x4 (d_C_intersect x1 x5 x3 cd
    cs)
  Curry_Prelude.C_False -> d_C_intersect x1 x5 x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x3 x4 x1 x5 l
    cd cs) (d_C__case_23 x3 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x3
    x4 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_23 x3 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_23"
    [show x3, show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_23" (showCons x6))

nd_C__case_23 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List
  t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_23 x3 x4 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_intersect x1 x5 x3 s0 cd cs)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C_intersect x1 x5 x3 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x3 x4 x1 x5 l
    s cd cs) (nd_C__case_23 x3 x4 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x3
    x4 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_23 x3 x4 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_23"
    [show x3, show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_23" (showCons x6))

d_C__case_24 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_24 x3 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_union x1 x5 x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x4 (d_C_union x1 x5 x3 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x3 x4 x1 x5 l
    cd cs) (d_C__case_24 x3 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x3
    x4 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_24 x3 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_24"
    [show x3, show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_24" (showCons x6))

nd_C__case_24 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List
  t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_24 x3 x4 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_union x1 x5 x3 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_union x1 x5 x3 s0 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_24 x3 x4 x1 x5 l
    s cd cs) (nd_C__case_24 x3 x4 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_24 x3
    x4 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_24 x3 x4 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_24"
    [show x3, show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_24" (showCons x6))

d_C__case_25 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_25 x4 x2 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x4 (d_C_deleteBy x1 x2 x5 cd
    cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x4 x2 x1 x5 l
    cd cs) (d_C__case_25 x4 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x4
    x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_25 x4 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_25"
    [show x4, show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_25" (showCons x6))

nd_C__case_25 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func t0
  (Func t0 Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_25 x4 x2 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_deleteBy x1 x2 x5 s0 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x4 x2 x1 x5 l
    s cd cs) (nd_C__case_25 x4 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x4
    x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_25 x4 x2 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_25"
    [show x4, show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_25" (showCons x6))

d_C__case_26 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_26 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x4 x1 x5 l cd
    cs) (d_C__case_26 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x4
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_26 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_26"
    [show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_26" (showCons x6))

nd_C__case_26 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
nd_C__case_26 x4 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x4 x1 x5 l s
    cd cs) (nd_C__case_26 x4 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x4
    x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_26 x4 x1 x5 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "List._case_26"
    [show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "List._case_26" (showCons x6))

